#include<bits\stdc++.h>


using namespace std;


#define ll long long
#define ld long double
#define pii pair<int, int>
#define all(x) (x).begin(), (x).end()
#define SYNC ios_base::sync_with_stdio(false);cin.tie(0);cout.tie(0);


int main()
{

    SYNC
    int n, k;
    cin >> n >> k;
    string s;
    cin >> s;

    vector<int> br(k, 0);

    for(int i = 0; i < n; i ++)
    {
        br[s[i] - 'a']++;

        int res = i + 1;
        for(int i = 0; i < k; i ++)
        {
            res = min(br[i] + 1, res);
        }
        cout << res << " ";
    }




    return 0;
}